<?php
/*
 * gimisa@yahoo.fr change to mysqli, had to install 
 * sudo apt-get install php-curl
 * sudo apt-get install php-xml
 */
echo "start <br/>";
//phpinfo();
$dbug=true;
include("databaseinfo.php");

//Supress all Warnings/Errors
//error_reporting(0);

$now = time();
if($dbug){echo "now ".$now."<br/>";}
//
// Search DB
//
$con=mysqli_connect ($DB_HOST, $DB_USER, $DB_PASSWORD,$DB_NAME);
if (mysqli_connect_errno())
  {
  echo "Failed to connect to MySQL: " . mysqli_connect_error();
  } else { echo "connected <br/> ";}
//mysqli_select_db($mysqli,$DB_NAME);
if($dbug){echo "database  ",$DB_HOST, $DB_USER,$DB_PASSWORD,$DB_NAME,"<br/>";}
function GetURL($host, $port, $url)
{
    global $now, $dbug;
    $url = "http://$host:$port/$url";
    if($dbug){echo "url ".$url."<br/>";}
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
    curl_setopt($ch, CURLOPT_TIMEOUT, 30);

    $data = curl_exec($ch);
    if($dbug){echo "data ".$data."<br/>";}
    if (curl_errno($ch) == 0)
    {
        curl_close($ch);
        return $data;
    }

    curl_close($ch);
    return "";
}

function CheckHost($hostname, $port)
{
    global $now,$dbug,$con;

    $xml = GetURL($hostname, $port, "?method=collector");
    if ($xml == "")	//No data was retrieved? (CURL may have timed out)
        $failcounter = "failcounter + 1";
    else
        $failcounter = "0";

    //Update nextcheck to be 10 minutes from now. The current OS instance
    //won't be checked again until at least this much time has gone by.
	$next = $now + 600;
    if(!$dbug)$next = $now + 1;

    mysqli_query($con,"UPDATE hostsregister SET nextcheck = $next," .
                " checked = 1, failcounter = " . $failcounter .
                " WHERE host = '" . mysqli_real_escape_string($con,$hostname) . "'" . 
                " AND port = '" . mysqli_real_escape_string($con,$port) . "'");

    if ($xml != "") 
        parse($hostname, $port, $xml);
}

function parse($hostname, $port, $xml)
{
    global $now,$con;

    ///////////////////////////////////////////////////////////////////////
    //
    // Search engine sim scanner
    //

    //
    // Load XML doc from URL
    //
    $objDOM = new DOMDocument();
    $objDOM->resolveExternals = false;

    //Don't try and parse if XML is invalid or we got an HTML 404 error.
    if ($objDOM->loadXML($xml) == False)
        return;

    //
    // Get the region data to update
    //
    $regiondata = $objDOM->getElementsByTagName("regiondata");

    //If returned length is 0, collector method may have returned an error
    if ($regiondata->length == 0)
        return;

    $regiondata = $regiondata->item(0);

    //
    // Update nextcheck so this host entry won't be checked again until after
    // the DataSnapshot module has generated a new set of data to be parsed.
    //
    $expire = $regiondata->getElementsByTagName("expire")->item(0)->nodeValue;
    $next = $now + $expire;

    $updater = mysqli_query($con,"UPDATE hostsregister SET nextcheck = $next " .
            "WHERE host = '" . mysqli_real_escape_string($con,$hostname) . "' AND " .
            "port = '" . mysqli_real_escape_string($con,$port) . "'");

    //
    // Get the region data to be saved in the database
    //
    $regionlist = $regiondata->getElementsByTagName("region");

    foreach ($regionlist as $region)
    {
        $regioncategory = $region->getAttributeNode("category")->nodeValue;

        //
        // Start reading the Region info
        //
        $info = $region->getElementsByTagName("info")->item(0);

        $regionuuid = $info->getElementsByTagName("uuid")->item(0)->nodeValue;

        $regionname = $info->getElementsByTagName("name")->item(0)->nodeValue;

        $regionhandle = $info->getElementsByTagName("handle")->item(0)->nodeValue;

        $url = $info->getElementsByTagName("url")->item(0)->nodeValue;

        //
        // First, check if we already have a region that is the same
        //
        $check = mysqli_query($con,"SELECT * FROM regions WHERE regionuuid = '" .
                mysqli_real_escape_string($con,$regionuuid) . "'");

        if (mysqli_num_rows($check) > 0)
        {
            mysqli_query($con,"DELETE FROM regions WHERE regionuuid = '" .
                     mysqli_real_escape_string($con,$regionuuid) . "'");
            mysqli_query($con,"DELETE FROM parcels WHERE regionuuid = '" .
                     mysqli_real_escape_string($con,$regionuuid) . "'");
            mysqli_query($con,"DELETE FROM allparcels WHERE regionUUID = '" .
                     mysqli_real_escape_string($con,$regionuuid) . "'");
            mysqli_query($con,"DELETE FROM parcelsales WHERE regionUUID = '" .
                     mysqli_real_escape_string($con,$regionuuid) . "'");
            mysqli_query($con,"DELETE FROM objects WHERE regionuuid = '" .
                     mysqli_real_escape_string($con,$regionuuid) . "'");
        }

        $data = $region->getElementsByTagName("data")->item(0);
        $estate = $data->getElementsByTagName("estate")->item(0);

        $username = $estate->getElementsByTagName("name")->item(0)->nodeValue;
        $useruuid = $estate->getElementsByTagName("uuid")->item(0)->nodeValue;

        $estateid = $estate->getElementsByTagName("id")->item(0)->nodeValue;

        //
        // Second, add the new info to the database
        //
        $sql = "REPLACE INTO regions VALUES('" .
                mysqli_real_escape_string($con,$regionname) . "','" .
                mysqli_real_escape_string($con,$regionuuid) . "','" .
                mysqli_real_escape_string($con,$regionhandle) . "','" .
                mysqli_real_escape_string($con,$url) . "','" .
                mysqli_real_escape_string($con,$username) ."','" .
                mysqli_real_escape_string($con,$useruuid) ."')";

        mysqli_query($con,$sql);

        //
        // Start reading the parcel info
        //
        $parcel = $data->getElementsByTagName("parcel");

        foreach ($parcel as $value)
        {
            $parcelname = $value->getElementsByTagName("name")->item(0)->nodeValue;

            $parceluuid = $value->getElementsByTagName("uuid")->item(0)->nodeValue;

            $infouuid = $value->getElementsByTagName("infouuid")->item(0)->nodeValue;

            $parcellanding = $value->getElementsByTagName("location")->item(0)->nodeValue;

            $parceldescription = $value->getElementsByTagName("description")->item(0)->nodeValue;

            $parcelarea = $value->getElementsByTagName("area")->item(0)->nodeValue;

            $parcelcategory = $value->getAttributeNode("category")->nodeValue;

            $parcelsaleprice = $value->getAttributeNode("salesprice")->nodeValue;

            $dwell = $value->getElementsByTagName("dwell")->item(0)->nodeValue;

            $owner = $value->getElementsByTagName("owner")->item(0);

            $owneruuid = $owner->getElementsByTagName("uuid")->item(0)->nodeValue;

            // Adding support for groups

            $group = $value->getElementsByTagName("group")->item(0);
            
            if ($group != "")
            {
                $groupuuid = $group->getElementsByTagName("groupuuid")->item(0)->nodeValue;
            }
            else
            {
                $groupuuid = "00000000-0000-0000-0000-000000000000";
            }

            //
            // Check bits on Public, Build, Script
            //
            $parcelforsale = $value->getAttributeNode("forsale")->nodeValue;
            $parceldirectory = $value->getAttributeNode("showinsearch")->nodeValue;
            $parcelbuild = $value->getAttributeNode("build")->nodeValue;
            $parcelscript = $value->getAttributeNode("scripts")->nodeValue;
            $parcelpublic = $value->getAttributeNode("public")->nodeValue;

            //
            // Save
            //
            $sql = "REPLACE INTO allparcels VALUES('" .
                    mysqli_real_escape_string($con,$regionuuid) . "','" .
                    mysqli_real_escape_string($con,$parcelname) . "','" .
                    mysqli_real_escape_string($con,$owneruuid) . "','" .
                    mysqli_real_escape_string($con,$groupuuid) . "','" .
                    mysqli_real_escape_string($con,$parcellanding) . "','" .
                    mysqli_real_escape_string($con,$parceluuid) . "','" .
                    mysqli_real_escape_string($con,$infouuid) . "','" .
                    mysqli_real_escape_string($con,$parcelarea) . "' )";

            mysqli_query($con,$sql);

            if ($parceldirectory == "true")
            {
                $sql = "REPLACE INTO parcels VALUES('" .
                        mysqli_real_escape_string($con,$regionuuid) . "','" .
                        mysqli_real_escape_string($con,$parcelname) . "','" .
                        mysqli_real_escape_string($con,$parceluuid) . "','" .
                        mysqli_real_escape_string($con,$parcellanding) . "','" .
                        mysqli_real_escape_string($con,$parceldescription) . "','" .
                        mysqli_real_escape_string($con,$parcelcategory) . "','" .
                        mysqli_real_escape_string($con,$parcelbuild) . "','" .
                        mysqli_real_escape_string($con,$parcelscript) . "','" .
                        mysqli_real_escape_string($con,$parcelpublic) . "','".
                        mysqli_real_escape_string($con,$dwell) . "','" .
                        mysqli_real_escape_string($con,$infouuid) . "','" .
                        mysqli_real_escape_string($con,$regioncategory) . "')";

                mysqli_query($con,$sql);
            }

            if ($parcelforsale == "true")
            {
                $sql = "REPLACE INTO parcelsales VALUES('" .
                        mysqli_real_escape_string($con,$regionuuid) . "','" .
                        mysqli_real_escape_string($con,$parcelname) . "','" .
                        mysqli_real_escape_string($con,$parceluuid) . "','" .
                        mysqli_real_escape_string($con,$parcelarea) . "','" .
                        mysqli_real_escape_string($con,$parcelsaleprice) . "','" .
                        mysqli_real_escape_string($con,$parcellanding) . "','" .
                        mysqli_real_escape_string($con,$infouuid) . "', '" .
                        mysqli_real_escape_string($con,$dwell) . "', '" .
                        mysqli_real_escape_string($con,$estateid) . "', '" .
                        mysqli_real_escape_string($con,$regioncategory) . "')";

                mysqli_query($con,$sql);
            }
        }

        //
        // Handle objects
        //
        $objects = $data->getElementsByTagName("object");

        foreach ($objects as $value)
        {
            $uuid = $value->getElementsByTagName("uuid")->item(0)->nodeValue;
            
            $title = $value->getElementsByTagName("title")->item(0)->nodeValue;
            
            $description = $value->getElementsByTagName("description")->item(0)->nodeValue;
            
            $flags = $value->getElementsByTagName("flags")->item(0)->nodeValue;

            $regionuuid = $value->getElementsByTagName("regionuuid")->item(0)->nodeValue;

            $parceluuid = $value->getElementsByTagName("parceluuid")->item(0)->nodeValue;

            $location = $value->getElementsByTagName("location")->item(0)->nodeValue;

            $imageuuid = $value->getElementsByTagName("image")->item(0)->nodeValue;
           
            if(empty($imageuuid)){
                
                $imageuuid =  "5748decc-f629-461c-9a36-a35a221fe21f";
            }
            
            mysqli_query($con,"REPLACE INTO objects VALUES('" .
                    mysqli_real_escape_string($con,$uuid) . "','" .
                    mysqli_real_escape_string($con,$parceluuid) . "','" .
                    mysqli_real_escape_string($con,$location) . "','" .
                    mysqli_real_escape_string($con,$title) . "','" .
                    mysqli_real_escape_string($con,$description) . "','" .
                    mysqli_real_escape_string($con,$regionuuid) . "','" .
                    mysqli_real_escape_string($con,$imageuuid)   . "')");
        }
    }
}

$sql = "SELECT host, port FROM hostsregister " .
        "WHERE `nextcheck` < $now  AND `checked` = 0 LIMIT 0,10";
if($dbug){echo "sql ".$sql."<br/>";}
$jobsearch = mysqli_query($con,$sql);

//
// If the sql query returns no rows, all entries in the hostsregister
// table have been checked. Reset the checked flag and re-run the
// query to select the next set of hosts to be checked.
//
if (mysqli_num_rows($jobsearch) == 0)
{
    mysqli_query($con,"UPDATE hostsregister SET `checked` = 0");
    $jobsearch = mysqli_query($con,$sql);
    return;
}
$jobsearch = mysqli_query($con,$sql);
if($dbug){echo "jobsearch row ".mysqli_num_rows($jobsearch)."<br/>";}
if($dbug){echo "fetch rows  ".mysqli_fetch_row($jobsearch)."<br/>";}
if($dbug){echo "fetch assoc  ".var_dump(mysqli_fetch_assoc($jobsearch))."<br/>";}

$jobs = mysqli_fetch_row($jobsearch);

//if($dbug){echo "job dump   ".var_dump($jobs)."<br/>";}
if($dbug){echo "job01 ".$jobs[0]." ".$job[1]."<br/>";}
if($dbug){print_r ($jobs);}
$result=mysqli_query($con,$sql);
/*
  // Fetch one and one row
while ($row=mysqli_fetch_row($result))
    {
    echo "rowss ".$row[0].$row[1]. "<br/>";
    }
  // Free result set
  mysqli_free_result($result);
$result=mysqli_query($con,$sql);
*/
while ($jobs=mysqli_fetch_row($result))
{
    if($dbug){echo "job ".$jobs[0]." ".$job[1]."<br/>";}
    CheckHost($jobs[0], $jobs[1]);
    
	}
?>

