<?php
/*
 * gimisa@yahoo.fr change to mysqli 191015
*/
//////////////////////////////////////////////////////////////////////////////
// register.php                                                             //
// (C) 2008, Fly-man-                                                       //
// This file contains the registration of a simulator to the database       //
// and checks if the simulator is new in the database or a reconnected one  //
//                                                                          //
// If the simulator is old, check if the nextcheck date > registration      //
// When the date is older, make a request to the Parser to grab new data    //
//////////////////////////////////////////////////////////////////////////////

include("databaseinfo.php");
//establish connection to master db server
$mysqli = mysqli_connect($DB_HOST, $DB_USER, $DB_PASSWORD);
mysqli_select_db($mysqli,$DB_NAME);

$hostname = $_GET['host'];
$port = $_GET['port'];
$service = $_GET['service'];

if ($hostname != "" && $port != "" && $service == "online")
{
    
    // Check if there is already a database row for this host
    $checkhost = mysqli_query($mysqli,"SELECT register FROM hostsregister WHERE " .
            "host = '" . mysqli_real_escape_string($mysqli,$hostname) . "' AND " .
            "port = '" . mysqli_real_escape_string($mysqli,$port) . "'" );

    // Get the request time as a timestamp for later
    $timestamp = $_SERVER['REQUEST_TIME'];

    // if greater than 1, check the nextcheck date
    if (mysqli_num_rows($checkhost) > 0)
    {
        $update = "UPDATE hostsregister SET " .
                "register = '" . mysqli_real_escape_string($mysqli,$timestamp) . "', " . 
                "nextcheck = '0', checked = '0', " .
                "failcounter = '0' " .  
                "WHERE host = '" . mysqli_real_escape_string($mysqli,$hostname) . "' AND " .
                "port = '" . mysqli_real_escape_string($mysqli,$port) . "'";
                
        echo "update: $update";

        $runupdate = mysqli_query($mysqli,$update);
    }
    else
    {
        $register = "INSERT INTO hostsregister VALUES ".
                    "('" . mysqli_real_escape_string($mysqli,$hostname) . "', " .
                    "'" . mysqli_real_escape_string($mysqli,$port) . "', " .
                    "'" . mysqli_real_escape_string($mysqli,$timestamp) . "', 0, 0, 0)";
        
        echo "register: $register";

        $runupdate = mysqli_query($mysqli,$register);
    }
}
elseif ($hostname != "" && $port != "" && $service = "offline")
{
        $delete = "DELETE FROM hostsregister " .
                "WHERE host = '" . mysqli_real_escape_string($mysqli,$hostname) . "' AND " .
                "port = '" . mysqli_real_escape_string($mysqli,$port) . "'";

        $rundelete = mysqli_query($mysqli,$delete);
}
?>
