<?php

$dbug=false;
include("databaseinfo.php");

//log to default system log  /var/log/sys
openlog("eventparserlog", LOG_PID | LOG_PERROR, LOG_LOCAL0);

//for debug see /var/log/syslog for posted results.
$access = date("Y/m/d H:i:s");
$processCount=0;
if ($dbug) syslog(LOG_WARNING, "eventparser.php access".$access);
/*
 * FUNCTIONS
 */

function evaluateAdult($evalAdult){
    global $dbug;
    $adultTerms=array("BDSM","adult","transgen","Bandage","Pedo","Bestial","hot Danse","Erwachsener","meerderjarig","взрослый","Vendaje","Bendaggio","Verband","Bandaże","Бинты" );
    $i=0;
       foreach ($adultTerms as $v) {
        $pos=stripos($evalAdult,$adultTerms[$i]);//case insensitive search 
        if($dbug)echo $pos,"<br>";
        if($pos!==FALSE){
            return 2;
        }
        $i++;
    }
    return 0;
    
}


function checkCategory ($validateCat ){
    /*
    categories are as follows:
        0 - Any  (NOTE: Event information will show "*Unspecified*")
        18- Discussion
        19- Sports
        20- Live Music
        22- Commercial
        23- Nightlife/Entertainment
        24- Games/Contests
        25- Pageants
        26- Education
        27- Arts and Culture
        28- Charity/Support Groups
        29- Miscellaneous
    */
    global $dbug;
    
    if(empty($validateCat))return 0;
    
    $searchCat = array("Discussion","Sport","Music","Commercial","Nightlife","Entertainment","Game","Contest","Pageant","Education","Art","Culture","Charity","Group","Miscellaneous","social","literature","lang-Multi");
    $catNum=array(18,19,20,22,23,23,24,24,25,26,27,27,28,28,29,23,27,26);
    $i=0;

    foreach ($searchCat as $v) {
        $pos=stripos($validateCat,$searchCat[$i]);//case insensitive search 
        if($dbug)echo $pos,"<br>";
        if($pos!==FALSE){
            if($dbug)echo ">i",$i,$searchCat[$i], " ";
            return $catNum[$i];
        }
        $i++;
    }
    return 0;
}


function createURL($globalPos,$simname,$slurl,$gridname){
             /*                       1    2        3  4    5
              * slurl: grid.kitely.com:8002:Caribou/209/113/21 
              * slurl: kalasiddhigrid.com:8002: 
              * slurl: grid.3rdrockgrid.com:8002:Melody 
              *  *          0                        1    3                  4  5   6
              * slurl: hop://goto.theencoreescape.com:8002/Encore Harbor Club/44/141/21 
              *                            1    2
              * slurl: grid.3rdrockgrid.com:8002:Antiquity 
              *                       1    2    3   4
              * slurl: grid.kitely.com:8002:389/689/22
              *                       1 
              * slurl: lfgrid.com:8002:Stonehaven 
              *                       1    2
              * slurl: grid.kitely.com:8002:Seanchai 
              *                               1    2
              * slurl: grid.metaversedepot.com:8002:IMA Outpost Alpha 
              *             0                1   3      4   5  6
              * slurl: hop://grid.kitely.com:8002/Naboo/183/41/2
              *                       1     2
              * slurl: grid.kitely.com:8002:Mount%20Calvary 
              *             0                1   3             4   5    6
              * slurl: hop://grid.kitely.com:8002/ISM%20Sandbox/246/210/21 
              * slrul: Hg.Osgrid.Org:80:Wright Plaza 
              *                          1    2
              * slurl: kalasiddhigrid.com:8002: 
              * 
              * urlencode(simname) 
              */
            global $dbug;
            $gridList=array("___","grid-kitely","grid-kalasiddhi","grid-ima","grid-3rdrockgrid","grid-theencoreescape","grid-littlefield") ;
            $urlList=array("","grid.kitely.com:8002:","kalasiddhigrid.com:8002:","grid.metaversedepot.com:8002:","goto.theencoreescape.com:8002:","lfgrid.com:8002:");
            if($dbug)echo "gridname $gridname";
            $slurl=urldecode($slurl);
            $pos0=stripos($slurl, "//" );
            $pos1=stripos($slurl, ":",$pos0 +1 );
            $pos2=$pos3=$pos4=$pos5=$pos5=$pos6=0;
            $localURL="";
            if($pos1<1){
                $key = array_search($gridname, $gridList);
                if($key >0 ) {
                    $slurl=$urlList[$key].$slurl;
                    $pos1=stripos($slurl, ":",$pos0 +1 );
                }else{
                    echo "---rejected gridname  $gridname url: $slurl";
                    return "continue";
                }
            }
            $pos2=stripos($slurl, ":",$pos1 +1 );
            $pos3=stripos($slurl, "/",$pos1 +1);
            if($pos3 > 0) $pos4=stripos($slurl, "/",$pos3 +1);
            if($pos4 > 0) $pos5=stripos($slurl, "/",$pos4 +1);
            if($pos5 > 0) $pos6=stripos($slurl, "/",$pos5 +1);
            $cnt=strlen($slurl);
            if($pos0 !== false)$pos0=$pos0+2;

            //next is to decode the surl provided to obtain one that can be use for teleportation in local chat and parse simname and position
            
            if($pos6 > 0  ){
                $globalPos=substr($slurl,$pos4 + 1,$cnt-$pos4);
                $simname=substr($slurl,$pos3 + 1,$pos4-$pos3-1);                                              
                $slurl=substr($slurl,$pos0,$pos1-$pos0)."|".substr($slurl,$pos1 +1,$pos3-$pos1-1)."|".rawurlencode($simname)."//".$globalPos;
                $localURL=rawurlencode($simname)."//".$globalPos;
            }elseif($pos5 > 0 ){
                $globalPos=substr($slurl,$pos3+ 2,$cnt-$pos3);
                $simname=substr($slurl,$pos2 + 1,$pos3-$pos2-1);
                $slurl=substr($slurl,$pos0,$pos1-$pos0)."|".substr($slurl,$pos1 +1,$pos2-$pos1-1)."|".rawurlencode($simname)."//".$globalPos;
                $localURL=rawurlencode($simname)."//".$globalPos;
            }elseif($pos4 > 0  and  $pos2 >0 ){
                $globalPos=substr($slurl,$pos2 + 1,$cnt-$pos2);
                $slurl=substr($slurl,$pos0,$pos1-$pos0)."|".substr($slurl,$pos1 +1,$pos2-$pos1-1)."//".$globalPos;
                $localURL=rawurlencode($simname)."//".$globalPos;
            }elseif($pos3 >0  and $pos2 >0 ){
                $simname=substr($slurl,$pos3+ 1,$cnt-$pos3-1);
                $slurl=substr($slurl,$pos0,$pos1-$pos0)."|".substr($slurl,$pos1 +1,$pos3-$pos1-1)."|".rawurlencode($simname)."//".$globalPos;
                $localURL=rawurlencode($simname)."//".$globalPos;
            }elseif($pos2 >0 ){
                if($pos2 == $cnt-1){
                    $slurl=substr($slurl,$pos0,$pos1-$pos0)."|".substr($slurl,$pos1 +1,$pos2-$pos1-1);
                    $localURL=rawurlencode($simname)."//".$globalPos;
                }else{
                    $simname=substr($slurl,$pos2+1,$cnt-$pos2);
                    $slurl=substr($slurl,$pos0,$pos1-$pos0)."|".substr($slurl,$pos1 +1,$pos2-$pos1-1)."|".rawurlencode($simname)."//".$globalPos;
                    $localURL=rawurlencode($simname)."//".$globalPos;
                }
            }else{
                 $slurl=substr($slurl,$pos0,$pos1-$pos0)."|".substr($slurl,$pos1 +1,$cnt-$pos1-1);
                 $localURL=rawurlencode($simname)."//".$globalPos;
                 
            }
            $globalPos=str_ireplace("/",",",$globalPos);
            
            if ($dbug )echo "+++pos:  0: $pos0 1: $pos1 2: $pos2 3: $pos3 4: $pos4 5: $pos5 6: $pos6 cnt: $cnt gpos: $globalPos URL: $slurl <br><br>";
            return array($globalPos,$simname,$slurl,$localURL);
}
//end functions


$htmlContent = file_get_contents("http://yourworlds.eu/hypevents/events.json");


if (empty($htmlContent)){
     if ($dbug) syslog(LOG_ERROR, "error with getting hypervents ".$access);
     die("error with getting hypervents ");
 
 }
 
 

$now = time();

if($dbug){echo "now ".$now."<br/>";}
//
// Search DB
//
$link = mysqli_connect($DB_HOST, $DB_USER, $DB_PASSWORD);

if($link === false){
    if ($dbug) syslog(LOG_ERROR, "could not connect to events database".$access);
    die("ERROR: Could not connect. " . mysqli_connect_error());
}

mysqli_select_db($link,"ossearch");
mysqli_set_charset($link,'utf8');
 
if($dbug)echo $htmlContent;

$data = json_decode($htmlContent,TRUE);

$sqdel= "DELETE FROM events";
mysqli_query($link,$sqdel);

foreach ($data as $row) {//loops thru events
    $processCount=$processCount+1;
    if($dbug ){
        echo " >title ",$row['title'];
        echo ' >start '.$row['start'];
        echo ' >slurl '.$row['hgurl'];
        echo ' >end '.$row['end'];
        echo ' >description '.$row['description'];
        echo ' >categories '.$row['categories'][0] ." ; ".$row['categories'][1]." ; ".$row['categories'][2] ;
        echo "<br>";
    }
    $creatoruuid='00000000-0000-0000-0000-000000000001';
    $owneruuid='00000000-0000-0000-0000-000000000001';
    $parcelUUID='00000000-0000-0000-0000-000000000001';
    $startTime=$row['start'];
    $endTime=$row['end'];
    if($dbug)echo "<br><br>startTime $startTime endTime $endTime" ;
    $slurl=$row['hgurl'];
    $covercharge=0;
    $coveramout=0;
    $globalPos="128./128./0.";
    $simname="grid default HG location";
    
    
    if(empty($startTime)  or empty($endTime) or empty($slurl)  ){
        echo "<br><br> --- rejected1 $startTime $endTime $slurl";
        continue;//jump to next record
    }
    
    $name=$row['title'];
    if(empty($name))$name = "Not specified" ;
    $name=str_ireplace("'"," ",$name);
    $description =strval($row['description']);
    $description=str_ireplace("'"," ",$description );
    $category=$row['categories'][0] ." ; ".$row['categories'][1].$name.$description ;
    $gridname=$row['categories'][0];
    $cattype=checkCategory($category);
    if($dbug)echo "categories '$category'  type  '$cattype' <br>";
    $dateUTC=strtotime($startTime);
    if($dateUTC<$now) $dateUTC=$now;
    $duration=strtotime( $endTime)-$dateUTC;
    
    
    if($duration <1){
        if($dbug)echo "<br><br> --- rejected2 $startTime $endTime duration $duration $slurl";
        continue;//jump to next record
    }
    
    if($dbug)echo "<br><br>'$startTime'  '$endTime'  diff: '$duration' <br>";
    if($dbug)echo "<br><br>simname: $simname cattype $cattype duration $duration slurl: $slurl  " ;
    $eventflags=evaluateAdult($name.$description);
    $response = createURL($globalPos,$simname,$slurl,$gridname);
    if($response[0]=="continue") continue;
    $globalPos=$response[0];
    $simname=$response[1];
    $slurl=$response[2];
    $localURL=$response[3];
    if($dbug)echo "<br><br>*** pos $globalPos,simname  $simname, surl $slurl";

    $description   = "teleport link paste in chat secondlife:///app/teleport/$slurl LOCAL TP: secondlife://$localURL DESCRIPTION: $description";
    
    /*
     * Exemple of events table ossearch database content :
     * cannot be null value must be filled in dateUTC must be higher then actual date
     * insert into events  (simname,category,creatoruuid, owneruuid,name, description, dateUTC,duration,covercharge, coveramount,parcelUUID, globalPos,eventflags) values
    (		'gimisa3',
    0,
    '00000000-0000-0000-0000-000000000001',
    '00000000-0000-0000-0000-000000000001',
    'test-gimisa5','teleport link paste in chat  secondlife:///app/teleport/3d.gimisa.ca|9000|gimisa3//128/128/0',1569866363,
    60,0,0,'00000000-0000-0000-0000-000000000001',
    '128,128,0',
    0
    );
     */

    $sqlin = " insert into events  (simname,category,creatoruuid, owneruuid,name, description, dateUTC,duration,covercharge,coveramount,parcelUUID,globalPos,eventflags) values ('$simname', $cattype,'$creatoruuid','$owneruuid','$name','$description',$dateUTC,$duration,$covercharge,$coveramout,'$parcelUUID', '$globalPos',$eventflags) " ;
    
   echo " <br><br>>>>sqlin $sqlin<br><br> ";

    mysqli_query($link, $sqlin) or die(mysqli_error($link));   

} 

echo   "$access $processCount records processed ";

?>
